#!/usr/bin/env python

import sys
import os
import math

def getCosDist(data, a, b):
    vecA={}
    vecB={}
    vecA[0] = data[a][2] - data[a][0]
    vecA[1] = data[a][3] - data[a][1]
    vecB[0] = data[b][2] - data[b][0]
    vecB[1] = data[b][3] - data[b][1]

    magnitudeA = math.sqrt(  1.0*vecA[0]*vecA[0]
                           + 0.0*vecA[1]*vecA[0]
                           + 0.0*vecA[0]*vecA[1]
                           + 1.0*vecA[1]*vecA[1])
    magnitudeB = math.sqrt(  1.0*vecB[0]*vecB[0]
                           + 0.0*vecB[1]*vecB[0]
                           + 0.0*vecB[0]*vecB[1]
                           + 1.0*vecB[1]*vecB[1])   
    magnitudeFactor = magnitudeA / magnitudeB
    if (magnitudeFactor > 1):
        magnitudeFactor = float(1.0) / magnitudeFactor

    dotProd = (  1.0*vecA[0]*vecB[0]
               + 0.0*vecA[1]*vecB[1]
               + 0.0*vecA[0]*vecB[0]
               + 1.0*vecA[1]*vecB[1])
    cosSimilarity = dotProd / (magnitudeA * magnitudeB)
    return (cosSimilarity * magnitudeFactor)

def main():
    if (len(sys.argv) != 3):
        print "processForMatlab.py <fileName> <action>"
        sys.exit(1)
    sFile = sys.argv[1]
    iTDist = 10
    iTheAction = int(sys.argv[2])

    data={}
    dataNewEpisode={}
    dataStep={}

    results={}
    counts={}
    maxEpisode = 0
    skippedFile = 0
    episodesFound = set()
    maxExpisode = 0

    try:
        f=open(sFile, 'r') 
    except IOError:
        print "Error opening" + sFile
        sys.exit()
    else:
        data = [map(float,line.split()) for line in f]

    rowCount=0
    stepNumber=-1
    for row in data:
        stepNumber += 1
        act = data[rowCount][2]
        #scale data [-1, 1]
        data[rowCount][0] = data[rowCount][0] + 0.0 
        data[rowCount][2] = data[rowCount][3] + 0.0
        data[rowCount][1] = data[rowCount][1] + 0.0
        data[rowCount][3] = data[rowCount][4] + 0.0

        data[rowCount][4] = int(act) #(0, 1, 2)
        dataNewEpisode[rowCount] = False
        if (rowCount != 0):
            if (data[rowCount][0] != data[rowCount-1][2] or data[rowCount][1] != data[rowCount-1][3]):
                dataNewEpisode[rowCount] = True
                stepNumber = 0
        dataStep[rowCount] = stepNumber
        #skip action
        rowCount+=1

    realRowCount = rowCount

    for rowCount in range(2,realRowCount,1):

        bottom = rowCount - iTDist
        top = rowCount + iTDist
        if (bottom < 0):
            bottom = 0 
        if (top > realRowCount):
            top = realRowCount
        for row in range(bottom, rowCount+1):
            if (dataNewEpisode[row] == True):
                bottom = row
        for row in range(rowCount+1, top):
            if (dataNewEpisode[row]):
                if (top >= row):
                    top = row

        count = 0
        if (data[rowCount][4] == iTheAction):
            matches={}
            matchDist={}
            for rowTest in range (bottom, top):
                if (rowTest != rowCount):
                    if (data[rowTest][4] == iTheAction):
                        dist = 0
                        dist += ((data[rowCount][0] - data[rowTest][0]) * (data[rowCount][0] - data[rowTest][0]))
                        dist += ((data[rowCount][1] - data[rowTest][1]) * (data[rowCount][1] - data[rowTest][1]))
                        dist = math.sqrt(dist)
                        if (dist > 0.0):
                            matches[count] = rowTest
                            matchDist[count] = dist
                            count += 1

            if (count >= 2):
                for matchIterator in range (0, count):
                    for matchIterator2 in range (matchIterator+1, count):
                        for i in range(0,4):
                            print data[rowCount][i],
                        print    
                        for i in range(0,4):
                            print data[matches[matchIterator]][i],
                        print                            
                        for i in range(0,4):
                            print data[matches[matchIterator2]][i],
                        print
                print "0 0 0 0" #flag
    f.close()
if __name__ == '__main__':
    main()
        
